/*ͻ
   Modul     pen_graf.h                                                  
                                                                         
   Compiler  Borland C++ 3.1                                             
                                                                         
   Datum     Karlsruhe, den 30.01.97                                     
                                                                         
   Autor     Frank Ruhnau                                                
                                                                         
   Update                                                                
  ĺ
   Inhalt    Grafische Ausgabe fuer den Pendelversuch                    
                                                                         
  ͼ*/
/*ͻ
   Modulkopf                                                              
  ͼ*/
  #ifndef _PEN_GRAF_H
  #define _PEN_GRAF_H
/*Ŀ
   Includedateien einladen                                                
  */
/*Ŀ
   Prototypendeklaraton                                                   
  */
  void irq_freq(void);		//in pendel.c definiert
  void menue(void);		//grafische Textausgabe fuer Menue
/*ͻ
   Unterprogramme                                                         
  ͼ*/
/*Ŀ
   Bildaufbau fuer grafische Darstellungen                                
  */
  void bildaufbau(void)
  {  float	skal_hor, skal_ver;
     int poly[8];
     rectangle(0,0,639,468);
     line(320,0,320,468);
     line(0,398,639,398);
     rectangle(0,469,639,479);
/**************************************************************************/
/**** Pendelmodell fuer Simulation ****/
     strcpy(text," Pendel-Simulation ");
     outtextxy(165,2,text);
     line(170,10,310,10);
     circle(S_XMODEL,S_YMODEL,3);
     line(S_XMODEL,S_YMODEL,S_XMODEL-10,S_YMODEL-10);
     lineto(S_XMODEL+10,S_YMODEL-10);
     lineto(S_XMODEL-10,S_YMODEL-10);
/**************************************************************************/
/**** Pendelmodell fuer Messung ****/
     strcpy(text," Pendel-Messung ");
     outtextxy(485,2,text);
     line(490,10,610,10);
     circle(M_XMODEL,M_YMODEL,3);
     line(M_XMODEL,M_YMODEL,M_XMODEL-10,M_YMODEL-10);
     lineto(M_XMODEL+10,M_YMODEL-10);
     lineto(M_XMODEL-10,M_YMODEL-10);

     setwritemode(COPY_PUT);
     setfillstyle(SOLID_FILL,getmaxcolor());
/**************************************************************************/
/**** Phasenportraet fuer Messung ****/
     skal_hor  = M_XPORT_SKAL*MAXWINKEL/3.0; //Phasenportraets 20 Grad Teilstriche
     skal_ver = M_YPORT_SKAL*MAXOMEGA /4.0; //Phasenportraets Winkelgeschw.

     line(M_XPORT    , M_YPORT+100, M_XPORT    , M_YPORT-100); //y-Linie
     line(M_XPORT+100, M_YPORT    , M_XPORT-100, M_YPORT);     //x-Linie
  /*** Pfeilspitze positive horizontale Achse ***/
     poly[0] = M_XPORT+100;     poly[1] = M_YPORT;
     poly[2] = M_XPORT+90;      poly[3] = M_YPORT+3;
     poly[4] = M_XPORT+90;      poly[5] = M_YPORT-3;
     poly[6] = M_XPORT+100;     poly[7] = M_YPORT;

     fillpoly(4, poly);
  /*** Pfeilspitze positive vertikale Achse ***/
     poly[0] = M_XPORT;         poly[1] = M_YPORT-100;
     poly[2] = M_XPORT-3;       poly[3] = M_YPORT-90;
     poly[4] = M_XPORT+3;       poly[5] = M_YPORT-90;
     poly[6] = M_XPORT;         poly[7] = M_YPORT-100;
     fillpoly(4, poly);
  /*** Einheit der horizontalen Achse ***/
     strcpy(text,"phi");
     outtextxy(M_XPORT +70,M_YPORT-25,text);
     strcpy(text,"[Grad]");
     outtextxy(M_XPORT +59,M_YPORT-16,text);
  /*** Einheit der vertikalen Achse ***/
     strcpy(text,"d phi");
     outtextxy(M_XPORT + 10,M_YPORT-100,text);
     line(M_XPORT + 10, M_YPORT -91, M_XPORT + 48, M_YPORT - 91);
     strcpy(text,"dt");
     outtextxy(M_XPORT + 10,M_YPORT-89,text);
     strcpy(text,"[1/s]");
     outtextxy(M_XPORT + 52,M_YPORT-95,text);
  /*** Skalenstriche positive horizontale Achse ***/
     line(M_XPORT+  skal_hor,M_YPORT-5,M_XPORT+  skal_hor,M_YPORT+5);
     line(M_XPORT+2*skal_hor,M_YPORT-5,M_XPORT+2*skal_hor,M_YPORT+5);
     line(M_XPORT+3*skal_hor,M_YPORT-5,M_XPORT+3*skal_hor,M_YPORT+5);
  /*** Skalenbeschriftung positive horizontale Achse ***/
     strcpy(text,"20");
     outtextxy(M_XPORT +  skal_hor-7,M_YPORT+8,text);
     strcpy(text,"40");
     outtextxy(M_XPORT +2*skal_hor-7,M_YPORT+8,text);
     strcpy(text,"60");
     outtextxy(M_XPORT +3*skal_hor-7,M_YPORT+8,text);
  /*** Skalenstriche negative horizontale Achse  ***/
     line(M_XPORT-  skal_hor,M_YPORT-5,M_XPORT-  skal_hor,M_YPORT+5);
     line(M_XPORT-2*skal_hor,M_YPORT-5,M_XPORT-2*skal_hor,M_YPORT+5);
     line(M_XPORT-3*skal_hor,M_YPORT-5,M_XPORT-3*skal_hor,M_YPORT+5);
  /*** Skalenstriche positive vertikale Achse ***/
     line(M_XPORT-5,M_YPORT-   skal_ver,M_XPORT+5,M_YPORT-   skal_ver);
     line(M_XPORT-5,M_YPORT- 2*skal_ver,M_XPORT+5,M_YPORT- 2*skal_ver);
     line(M_XPORT-5,M_YPORT- 3*skal_ver,M_XPORT+5,M_YPORT- 3*skal_ver);
     line(M_XPORT-5,M_YPORT- 4*skal_ver,M_XPORT+5,M_YPORT- 4*skal_ver);
  /*** Skalenbeschriftung positive vertikale Achse ***/
     strcpy(text,"0.5");
     outtextxy(M_XPORT-30,M_YPORT-   skal_ver-5,text);
     strcpy(text,"1.0");
     outtextxy(M_XPORT-30,M_YPORT- 2*skal_ver-5,text);
     strcpy(text,"1.5");
     outtextxy(M_XPORT-30,M_YPORT- 3*skal_ver-5,text);
     strcpy(text,"2.0");
     outtextxy(M_XPORT-30,M_YPORT- 4*skal_ver-5,text);
  /*** Skalenstriche negative vertikale Achse ***/
     line(M_XPORT-5,M_YPORT+   skal_ver,M_XPORT+5,M_YPORT+   skal_ver);
     line(M_XPORT-5,M_YPORT+ 2*skal_ver,M_XPORT+5,M_YPORT+ 2*skal_ver);
     line(M_XPORT-5,M_YPORT+ 3*skal_ver,M_XPORT+5,M_YPORT+ 3*skal_ver);
     line(M_XPORT-5,M_YPORT+ 4*skal_ver,M_XPORT+5,M_YPORT+ 4*skal_ver);
/**************************************************************************/
/**** Phasenportraet fuer Simulation ****/
     skal_hor  = S_XPORT_SKAL*MAXWINKEL/3.0; //Portraets 20 Grad Teilstriche
     skal_ver = S_YPORT_SKAL*MAXOMEGA /4.0;  //Phasenportraets Winkelgeschw.

     line(S_XPORT    , S_YPORT+100, S_XPORT    , S_YPORT-100); //y-Linie
     line(S_XPORT+100, S_YPORT    , S_XPORT-100, S_YPORT);     //x-Linie
  /*** Pfeilspitze positive horizontale Achse ***/
     poly[0] = S_XPORT+100;     poly[1] = S_YPORT;
     poly[2] = S_XPORT+90;      poly[3] = S_YPORT+3;
     poly[4] = S_XPORT+90;      poly[5] = S_YPORT-3;
     poly[6] = S_XPORT+100;     poly[7] = S_YPORT;
     fillpoly(4, poly);
  /*** Pfeilspitze positive vertikale Achse ***/
     poly[0] = S_XPORT;         poly[1] = S_YPORT-100;
     poly[2] = S_XPORT-3;       poly[3] = S_YPORT-90;
     poly[4] = S_XPORT+3;       poly[5] = S_YPORT-90;
     poly[6] = S_XPORT;         poly[7] = S_YPORT-100;
     fillpoly(4, poly);
  /*** Einheit der horizontalen Achse ***/
     strcpy(text,"phi");
     outtextxy(S_XPORT +70,S_YPORT-25,text);
     strcpy(text,"[Grad]");
     outtextxy(S_XPORT +59,S_YPORT-16,text);
  /*** Einheit der vertikalen Achse ***/
     strcpy(text,"d phi");
     outtextxy(S_XPORT + 10,S_YPORT-100,text);
     line(S_XPORT + 10, S_YPORT -91, S_XPORT + 48, S_YPORT - 91);
     strcpy(text,"dt");
     outtextxy(S_XPORT + 10,S_YPORT-89,text);
     strcpy(text,"[1/s]");
     outtextxy(S_XPORT + 52,S_YPORT-95,text);
  /*** Skalenstriche positive horizontale Achse ***/
     line(S_XPORT+  skal_hor,S_YPORT-5,S_XPORT+  skal_hor,S_YPORT+5);
     line(S_XPORT+2*skal_hor,S_YPORT-5,S_XPORT+2*skal_hor,S_YPORT+5);
     line(S_XPORT+3*skal_hor,S_YPORT-5,S_XPORT+3*skal_hor,S_YPORT+5);
  /*** Skalenbeschriftung positive horizontale Achse ***/
     strcpy(text,"20");
     outtextxy(S_XPORT +  skal_hor-7,S_YPORT+8,text);
     strcpy(text,"40");
     outtextxy(S_XPORT + 2*skal_hor-7,S_YPORT+8,text);
     strcpy(text,"60");
     outtextxy(S_XPORT + 3*skal_hor-7,S_YPORT+8,text);
  /*** Skalenstriche negative horizontale Achse  ***/
     line(S_XPORT-  skal_hor,S_YPORT-5,S_XPORT-  skal_hor,S_YPORT+5);
     line(S_XPORT-2*skal_hor,S_YPORT-5,S_XPORT-2*skal_hor,S_YPORT+5);
     line(S_XPORT-3*skal_hor,S_YPORT-5,S_XPORT-3*skal_hor,S_YPORT+5);
  /*** Skalenstriche positive vertikale Achse ***/
     line(S_XPORT-5,S_YPORT-   skal_ver,S_XPORT+5,S_YPORT-   skal_ver);
     line(S_XPORT-5,S_YPORT- 2*skal_ver,S_XPORT+5,S_YPORT- 2*skal_ver);
     line(S_XPORT-5,S_YPORT- 3*skal_ver,S_XPORT+5,S_YPORT- 3*skal_ver);
     line(S_XPORT-5,S_YPORT- 4*skal_ver,S_XPORT+5,S_YPORT- 4*skal_ver);
  /*** Skalenbeschriftung positive vertikale Achse ***/
     strcpy(text,"0.5");
     outtextxy(S_XPORT-30,S_YPORT-   skal_ver-5,text);
     strcpy(text,"1.0");
     outtextxy(S_XPORT-30,S_YPORT- 2*skal_ver-5,text);
     strcpy(text,"1.5");
     outtextxy(S_XPORT-30,S_YPORT- 3*skal_ver-5,text);
     strcpy(text,"2.0");
     outtextxy(S_XPORT-30,S_YPORT- 4*skal_ver-5,text);
  /*** Skalenstriche negative vertikale Achse ***/
     line(S_XPORT-5,S_YPORT+   skal_ver,S_XPORT+5,S_YPORT+   skal_ver);
     line(S_XPORT-5,S_YPORT+ 2*skal_ver,S_XPORT+5,S_YPORT+ 2*skal_ver);
     line(S_XPORT-5,S_YPORT+ 3*skal_ver,S_XPORT+5,S_YPORT+ 3*skal_ver);
     line(S_XPORT-5,S_YPORT+ 4*skal_ver,S_XPORT+5,S_YPORT+ 4*skal_ver);
/**************************************************************************/
/**** Amplitudenverlauf fuer Messung ****/
     skal_ver = M_YAMPLI_SKAL*MAXWINKEL/3.0;    //20 Grad Teilstriche
     skal_hor = XAMPLI_SKAL*MAXTIME/7.0;       //Phasenportraets Winkelgeschw.

     line(M_XAMPLI,M_YAMPLI-100,M_XAMPLI,M_YAMPLI+100);
     line(M_XAMPLI-10,M_YAMPLI,M_XAMPLI+290,M_YAMPLI);
  /*** Pfeilspitze positive horizontale Achse ***/
     poly[0] = M_XAMPLI+290;      poly[1] = M_YAMPLI;
     poly[2] = M_XAMPLI+280;      poly[3] = M_YAMPLI+3;
     poly[4] = M_XAMPLI+280;      poly[5] = M_YAMPLI-3;
     poly[6] = M_XAMPLI+290;      poly[7] = M_YAMPLI;
     fillpoly(4, poly);
  /*** Pfeilspitze positive vertikale Achse ***/
     poly[0] = M_XAMPLI;          poly[1] = M_YAMPLI-109;
     poly[2] = M_XAMPLI-3;        poly[3] = M_YAMPLI-99;
     poly[4] = M_XAMPLI+3;        poly[5] = M_YAMPLI-99;
     poly[6] = M_XAMPLI;          poly[7] = M_YAMPLI-109;
     fillpoly(4, poly);
  /*** Einheit der horizontalen Achse ***/
     strcpy(text,"t");
     outtextxy(M_XAMPLI + 275,M_YAMPLI-25,text);
     strcpy(text,"[s]");
     outtextxy(M_XAMPLI + 275,M_YAMPLI-16,text);
  /*** Einheit der vertikalen Achse ***/
     strcpy(text,"phi");
     outtextxy(M_XAMPLI +10,M_YAMPLI-115,text);
     strcpy(text,"[Grad]");
     outtextxy(M_XAMPLI +10,M_YAMPLI-106,text);
  /*** Skalenstriche positive horizontale Achse ***/
     line(M_XAMPLI+  skal_hor,M_YAMPLI-5,M_XAMPLI+  skal_hor,M_YAMPLI+5);
     line(M_XAMPLI+2*skal_hor,M_YAMPLI-5,M_XAMPLI+2*skal_hor,M_YAMPLI+5);
     line(M_XAMPLI+3*skal_hor,M_YAMPLI-5,M_XAMPLI+3*skal_hor,M_YAMPLI+5);
     line(M_XAMPLI+4*skal_hor,M_YAMPLI-5,M_XAMPLI+4*skal_hor,M_YAMPLI+5);
     line(M_XAMPLI+5*skal_hor,M_YAMPLI-5,M_XAMPLI+5*skal_hor,M_YAMPLI+5);
     line(M_XAMPLI+6*skal_hor,M_YAMPLI-5,M_XAMPLI+6*skal_hor,M_YAMPLI+5);
     line(M_XAMPLI+7*skal_hor,M_YAMPLI-5,M_XAMPLI+7*skal_hor,M_YAMPLI+5);
  /*** Skalenbeschriftung positive horizontale Achse ***/
     strcpy(text,"50");
     outtextxy(M_XAMPLI +  skal_hor-7,M_YAMPLI+8,text);
     strcpy(text,"100");
     outtextxy(M_XAMPLI +2*skal_hor-12,M_YAMPLI+8,text);
     strcpy(text,"150");
     outtextxy(M_XAMPLI +3*skal_hor-12,M_YAMPLI+8,text);
     strcpy(text,"200");
     outtextxy(M_XAMPLI +4*skal_hor-12,M_YAMPLI+8,text);
     strcpy(text,"250");
     outtextxy(M_XAMPLI +5*skal_hor-12,M_YAMPLI+8,text);
     strcpy(text,"300");
     outtextxy(M_XAMPLI +6*skal_hor-12,M_YAMPLI+8,text);
     strcpy(text,"350");
     outtextxy(M_XAMPLI +7*skal_hor-12,M_YAMPLI+8,text);
  /*** Skalenstriche positive vertikale Achse ***/
     line(M_XAMPLI-5,M_YAMPLI-   skal_ver,M_XAMPLI+5,M_YAMPLI-   skal_ver);
     line(M_XAMPLI-5,M_YAMPLI- 2*skal_ver,M_XAMPLI+5,M_YAMPLI- 2*skal_ver);
     line(M_XAMPLI-5,M_YAMPLI- 3*skal_ver,M_XAMPLI+5,M_YAMPLI- 3*skal_ver);
  /*** Skalenbeschriftung positive vertikale Achse ***/
     strcpy(text,"20");
     outtextxy(M_XAMPLI-18,M_YAMPLI-   skal_ver-8,text);
     strcpy(text,"40");
     outtextxy(M_XAMPLI-18,M_YAMPLI- 2*skal_ver-8,text);
     strcpy(text,"60");
     outtextxy(M_XAMPLI-18,M_YAMPLI- 3*skal_ver-8,text);
  /*** Skalenstriche negative vertikale Achse ***/
     line(M_XAMPLI-5,M_YAMPLI+   skal_ver,M_XAMPLI+5,M_YAMPLI+   skal_ver);
     line(M_XAMPLI-5,M_YAMPLI+2*skal_ver,M_XAMPLI+5,M_YAMPLI+ 2*skal_ver);
     line(M_XAMPLI-5,M_YAMPLI+3*skal_ver,M_XAMPLI+5,M_YAMPLI+ 3*skal_ver);
/**** Amplitudenverlauf fuer Messung ****/
     line(S_XAMPLI,S_YAMPLI-100,S_XAMPLI,S_YAMPLI+100);
     line(S_XAMPLI-10,S_YAMPLI,S_XAMPLI+290,S_YAMPLI);

  /*** Pfeilspitze positive horizontale Achse ***/
     poly[0] = S_XAMPLI+290;      poly[1] = M_YAMPLI;
     poly[2] = S_XAMPLI+280;      poly[3] = M_YAMPLI+3;
     poly[4] = S_XAMPLI+280;      poly[5] = M_YAMPLI-3;
     poly[6] = S_XAMPLI+290;      poly[7] = M_YAMPLI;
     fillpoly(4, poly);
  /*** Pfeilspitze positive vertikale Achse ***/
     poly[0] = S_XAMPLI;          poly[1] = S_YAMPLI-109;
     poly[2] = S_XAMPLI-3;        poly[3] = S_YAMPLI-99;
     poly[4] = S_XAMPLI+3;        poly[5] = S_YAMPLI-99;
     poly[6] = S_XAMPLI;          poly[7] = S_YAMPLI-109;
     fillpoly(4, poly);
  /*** Einheit der horizontalen Achse ***/
     strcpy(text,"t");
     outtextxy(S_XAMPLI + 275,S_YAMPLI-25,text);
     strcpy(text,"[s]");
     outtextxy(S_XAMPLI + 275,S_YAMPLI-16,text);
  /*** Einheit der vertikalen Achse ***/
     strcpy(text,"phi");
     outtextxy(S_XAMPLI +10,S_YAMPLI-115,text);
     strcpy(text,"[Grad]");
     outtextxy(S_XAMPLI +10,S_YAMPLI-106,text);
  /*** Skalenstriche positive horizontale Achse ***/
     line(S_XAMPLI+  skal_hor,S_YAMPLI-5,S_XAMPLI+  skal_hor,S_YAMPLI+5);
     line(S_XAMPLI+2*skal_hor,S_YAMPLI-5,S_XAMPLI+2*skal_hor,S_YAMPLI+5);
     line(S_XAMPLI+3*skal_hor,S_YAMPLI-5,S_XAMPLI+3*skal_hor,S_YAMPLI+5);
     line(S_XAMPLI+4*skal_hor,S_YAMPLI-5,S_XAMPLI+4*skal_hor,S_YAMPLI+5);
     line(S_XAMPLI+5*skal_hor,S_YAMPLI-5,S_XAMPLI+5*skal_hor,S_YAMPLI+5);
     line(S_XAMPLI+6*skal_hor,S_YAMPLI-5,S_XAMPLI+6*skal_hor,S_YAMPLI+5);
     line(S_XAMPLI+7*skal_hor,S_YAMPLI-5,S_XAMPLI+7*skal_hor,S_YAMPLI+5);
  /*** Skalenbeschriftung positive horizontale Achse ***/
     strcpy(text,"50");
     outtextxy(S_XAMPLI +  skal_hor-7 ,S_YAMPLI+8,text);
     strcpy(text,"100");
     outtextxy(S_XAMPLI +2*skal_hor-12,S_YAMPLI+8,text);
     strcpy(text,"150");
     outtextxy(S_XAMPLI +3*skal_hor-12,S_YAMPLI+8,text);
     strcpy(text,"200");
     outtextxy(S_XAMPLI +4*skal_hor-12,S_YAMPLI+8,text);
     strcpy(text,"250");
     outtextxy(S_XAMPLI +5*skal_hor-12,S_YAMPLI+8,text);
     strcpy(text,"300");
     outtextxy(S_XAMPLI +6*skal_hor-12,S_YAMPLI+8,text);
     strcpy(text,"350");
     outtextxy(S_XAMPLI +7*skal_hor-12,S_YAMPLI+8,text);
  /*** Skalenstriche positive vertikale Achse ***/
     line(S_XAMPLI-5,S_YAMPLI-   skal_ver,S_XAMPLI+5,S_YAMPLI-   skal_ver);
     line(S_XAMPLI-5,S_YAMPLI- 2*skal_ver,S_XAMPLI+5,S_YAMPLI- 2*skal_ver);
     line(S_XAMPLI-5,S_YAMPLI- 3*skal_ver,S_XAMPLI+5,S_YAMPLI- 3*skal_ver);
  /*** Skalenbeschriftung positive vertikale Achse ***/
     strcpy(text,"20");
     outtextxy(S_XAMPLI-18,S_YAMPLI-   skal_ver-8,text);
     strcpy(text,"40");
     outtextxy(S_XAMPLI-18,S_YAMPLI- 2*skal_ver-8,text);
     strcpy(text,"60");
     outtextxy(S_XAMPLI-18,S_YAMPLI- 3*skal_ver-8,text);
  /*** Skalenstriche negative vertikale Achse ***/
     line(S_XAMPLI-5,S_YAMPLI+   skal_ver,S_XAMPLI+5,S_YAMPLI+   skal_ver);
     line(S_XAMPLI-5,S_YAMPLI+ 2*skal_ver,S_XAMPLI+5,S_YAMPLI+ 2*skal_ver);
     line(S_XAMPLI-5,S_YAMPLI+ 3*skal_ver,S_XAMPLI+5,S_YAMPLI+ 3*skal_ver);

     setfillstyle(SOLID_FILL, BLACK);
     setwritemode(XOR_PUT);

     gotoxy(2,7);
     printf("m: %4.3f kg",m);            //Pendelmasse
     gotoxy(2,8);
     printf("s: %1.3f m",s);            //Schwerpunktsabstand der Gesamtmasse
     gotoxy(2,9);
     printf("d: %1.3f" ,d);            //Daempfung
     gotoxy(2,10);
     printf("r: %1.3f" ,r);            //Reibung
  }
/*Ŀ
   Menue Tastenverarbeitung                                   	           
  */
  void menue_tasten(int key)
  {  switch(key)
     {  case F1 : s_model   =! s_model;	   //Model fuer Simulation
		  break;
	case F2  :s_portraet=! s_portraet; //Phasenportraet fuer Simul.
		  break;
	case F3  :s_ampli   =! s_ampli;    //Amplituten-Zeit-Diag. fuer Simul.
		  break;
	case F4  :s_peri    =! s_peri;     //Periodendauer fuer Simul.
		  break;
	case F5  :s_synchron=!s_synchron;  //Amplituten-Zeit-Diag. fuer Simul.
		  break;
	case F7  :m_model   =! m_model;	   //Model fuer Messung
		  break;
	case F8  :m_portraet=! m_portraet; //Phasenportraet fuer Messung
		  break;
	case F9  :m_ampli   =! m_ampli;    //Amplituten-Zeit-Diag. fuer Simul.
		  break;
	case F10 :m_peri    =! m_peri;     //Periodendauer fuer Simul.
		  break;
	case F12 :irq_freq();              //Eingabemenue fuer IRQ-Frequenz
     }
     menue();				   //-Ausgabe
  }
/*Ŀ
   Menue Ausgabe                                              	           
  */
  void menue(void)
  {
     bar(5,400,300,438);   //Textfeld loeschen
     if(s_model != 0)      strcpy(text,"<F1> Pendelmodel      : ein");
     else                  strcpy(text,"<F1> Pendelmodel      : aus");
     outtextxy(5,400,text);
     if(s_portraet != 0)   strcpy(text,"<F2> Phasenportraet   : ein");
     else                  strcpy(text,"<F2> Phasenportraet   : aus");
     outtextxy(5,410,text);
     if(s_ampli != 0)      strcpy(text,"<F3> Amplitudenverlauf: ein");
     else                  strcpy(text,"<F3> Amplitudenverlauf: aus");
     outtextxy(5,420,text);
     if(s_peri!= 0)        strcpy(text,"<F4> Periodendauer    : ein");
     else                  strcpy(text,"<F4> Periodendauer    : aus");
     outtextxy(5,430,text);
			   strcpy(text,"<F5> Synchronisieren!");
     outtextxy(5,450,text);

     bar(325,400,630,438);   //Textfeld loeschen
     if(m_model != 0)      strcpy(text,"<F7>  Pendelmodel      : ein");
     else                  strcpy(text,"<F7>  Pendelmodel      : aus");
     outtextxy(325,400,text);
     if(m_portraet != 0)   strcpy(text,"<F8>  Phasenportraet   : ein");
     else                  strcpy(text,"<F8>  Phasenportraet   : aus");
     outtextxy(325,410,text);
     if(m_ampli != 0)      strcpy(text,"<F9>  Amplitudenverlauf: ein");
     else                  strcpy(text,"<F9>  Amplitudenverlauf: aus");
     outtextxy(325,420,text);
     if(m_peri!= 0)        strcpy(text,"<F10> Periodendauer    : ein");
     else                  strcpy(text,"<F10> Periodendauer    : aus");
     outtextxy(325,430,text);

     strcpy(text,"<ESC> Ende!");
     outtextxy(5,471,text);

     bar(110,471,638,478); 		  //unteres Textfeld loeschen

     strcpy(text,"<F12> IRQ-Freq.[Hz]:");
     sprintf(textin,"%6.2f",irqfreq);
     strcat(text,textin);
     outtextxy(110,471,text);

     strcpy(text,"Errors: ");
     sprintf(textin,"%d",errors);
     strcat(text,textin);
     outtextxy(400,471,text);
  };
  #endif