/*ͻ
   Modul     pen_hw.h                                                    
                                                                         
   Compiler  Borland C++ 3.1                                             
                                                                         
   Datum     Karlsruhe, den 13.01.97                                     
                                                                         
   Autor     Frank Ruhnau                                                
                                                                         
   Update                                                                
  ĺ
   Inhalt    Initialisierungroutinen fuer  die PC-Hardware               
             beim Pendelversuch                                          
  ͼ*/
/*ͻ
   Modulkopf                                                              
  ͼ*/
  #ifndef _PEN_HW_H
  #define _PEN_HW_H
/*Ŀ
   Includedateien einladen                                                
  */
/*Ŀ
   Prototypendeklaraton                                                   
  */
  void graphinit(void);
  void initinter(void); //Einfuegen Int.-Routine in Vektortab./ Int freigeben
  void initports(void);
  void inittimer(void);
  void interrupt read_ad(void);        //Interruptroutine fuer AD-Wandler
  void resetinter (void);   //Interrupts sperren /alte Int.-Routine eintragen
/*ͻ
   Unterprogramme                                                         
  ͼ*/
/*Ŀ
    Timer1 vorbereiten und starten                                        
  */
  void inittimer(void)
  {  unsigned int dummy;
     outportb(timercontr,t1mode);
     dummy=t1_teiler; 			//Low Byte
     outportb(timer1,dummy);
     dummy=(dummy >> 8);     		//High Byte
     outportb(timer1,dummy);
  }
/*Ŀ
    I/O-Baustein initialisieren fuer 12-Bit des AD-Wandlers               
  */
  void initports (void)
  {  outportb(IO_CONTR,IO_INIT);     outportb(IO_PORTC,AUFLOESUNG);
  }
/*Ŀ
    Einfuegen der Interruptroutine in die Vektortabelle und Int freigeben 
  */
  void initinter(void)
  {  old_vect12= getvect(irq12); 	//alte Interruptroutine sichern
     setvect(irq12, read_ad);		//neue Interruptroutine einfgen
     outportb(slavemask, inportb(slavemask) & 0xEF);
					//IRQ12 freigeben (Bit 4 lschen)
					//Maske 0xEFh
     enable();    		        //Interrupts allgemein anschalten
  }
/*Ŀ
    Interrupts sperren und alte Interruptroutine wieder eintragen         
  */
  void resetinter(void)
  {  outportb(slavemask, inportb(slavemask) | 0x10);
					//IRQ12 sperren (Bit 4 setzen)
					//Maske 0x10h
     setvect(irq12, old_vect12);	//alte Interruptroutine einfgen
  }
/*Ŀ
   Graphiktreiber initialisieren                                          
  */
   void	graphinit(void)
  { int gdriver=DETECT, gmode, errorcode;
    initgraph(&gdriver,&gmode,""); //Graphiktreiber und-mode ermitteln
    errorcode = graphresult();
    if (errorcode != grOk)  /* an error occurred */
    {  cprintf("Graphics error: %s\n", grapherrormsg(errorcode));
       getch();
       exit(1); /* terminate with an error code */
    }
    cleardevice();      setbkcolor(BLACK);      //Hintergrundfarbe setzen
  };
  #endif