/*ͻ
   Modul     Motor.h                                                     
                                                                         
   Compiler  Borland C++ 3.1                                             
                                                                         
   Datum     Karlsruhe, den 04.07.94                                     
                                                                         
   Autor     A. Seifert                                                  
                                                                         
   Update    04.07.1994, Hartung Wilstermann                             
  Ķ
   Inhalt    Graphische Anzeige der Motordrehzahl                        
  ͼ*/

/*ͻ
   Modulkopf                                                              
  ͼ*/
  #ifndef _MOTOR_H
  #define _MOTOR_H

/*Ŀ
   Globale Variablen                                                      
  */
  int t_high,t_starty,t_length,t_startx;  // Variablen fr Drehzahlanzeige
  int text_x,text_y;

/*Ŀ
   Init_Tacho: Zeichnet den Drehzahlmesser (grafisch) und setzt alle      
               bentigten Variablen auf sinnvolle Anfangswerte.	   
  */
  void init_tacho(void)
  {
    int max_x, max_y, i, y_pos, x_fakt;
    char z_str[18];

    cleardevice();
    max_x = getmaxx();
    max_y = getmaxy();
    settextjustify(CENTER_TEXT,TOP_TEXT);
    t_high = max_y/6;               	/* Hhe des Balkens berechnen */
    t_starty = (max_y/3 - t_high)/2;	/* Startposition y-Koord. */
    t_length = max_x*0.75;          	/* Maximale Lnge des Balkens */
    t_startx = (max_x-t_length)/2;	/* Startposition x-Koord. */
    rectangle(0,0,max_x,max_y/3);	        /* Box um die Anzeige herum zeichnen */
    setcolor(RED);
    rectangle(t_startx,t_starty-1,t_startx+t_length+1,t_starty+t_high+1);
    setcolor(GREEN);
    y_pos = t_starty - (t_starty/3);
    x_fakt = t_length/8 + 1;
    for (i=0;i != 9;i++)
     {
      line(t_startx+i*x_fakt,t_starty-1,t_startx+i*x_fakt,y_pos);
      itoa(i*50,z_str,10);
      outtextxy(t_startx+i*x_fakt,y_pos-10,z_str);
     };
    setcolor(WHITE);
    settextjustify(LEFT_TEXT,TOP_TEXT);
    text_y = t_starty*3/2+t_high;
    text_x = t_startx+t_length/2;
    outtextxy(t_startx,text_y,"Drehzahl in 1/min");
    outtextxy(text_x,text_y,"Aktuell: ");
    text_x += textwidth("Aktuell:  ");
  };

/*Ŀ
   Tacho: Gibt die Drehzahl grafisch in Form eines Balkens aus            
  */
  void tacho(unsigned int dreh)
  {
    unsigned long int tmp;
    int anz_x;
    char z_str[18];
    itoa(dreh,z_str,10);
    setfillstyle(SOLID_FILL,BLACK);
    bar(text_x,text_y,text_x+40,text_y+10);
    setfillstyle(SOLID_FILL,getmaxcolor());
    settextjustify(LEFT_TEXT,TOP_TEXT);
    outtextxy(text_x,text_y,z_str);
    if (dreh > 400) dreh = 400;
    tmp = dreh * (long)t_length;   // Balkenlnge ergibt sich aus der Drehzahl */
    anz_x=t_startx + tmp/400;	   // dividiert durch die max. Drehzahl mal
				   // der max. Balkenlnge.
    setfillstyle(SOLID_FILL,getmaxcolor());
    bar(t_startx,t_starty,anz_x,t_starty+t_high);
    if (dreh < 400)
    {
      setfillstyle(SOLID_FILL,BLACK);
      bar(anz_x+1,t_starty,t_startx+t_length,t_starty+t_high);
    }
  };

  #endif