;ͻ
; Programm  Versuch5.asm                                                  
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Hartung Wilstermann & Ingo Gabriel                            
;Ķ
; Inhalt    Ampelsteuerung                                                
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486			;Prozessortyp angeben, 486 Code zulassen
	DOSSEG			;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL	;Speichermodell auswaehlen
	STACK   100h		;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS		equ 21h	;MS-DOS Interruptnummer
	EXIT   	 	equ 4Ch	;Programmende

;Ŀ
;  Konstanten fuer Lichtsignale                                           
;
        Timer	        equ 210000 ; Warte in Zehntel-Sekunden
        Tgelb           equ 20
        Tsperr          equ 50
        TNgruen         equ 100
        THgruen         equ 100
        TNrot_THrot     equ Tsperr - 2 * Tgelb

;Ŀ
;  Konstanten fuer den Interruptcontroller 8259A                          
;
	Master	equ 20h		;Adresse des Kontrollregisters des 1. Inter-
				;ruptcontrollers
	Slave	equ 0A0h	;Adresse des Kontrollregisters des 2. Inter-
				;ruptcontrollers
	IRQMask_1  equ  21h	;Adresse der Maske des 1. IR-Controllers
	IRQMask_2  equ 0A1h	;Adresse der Maske des 2. IR-Controllers
	GetIntVec  equ 35h	;Funktionscode Get Interrupt Vector
	SetIntVec  equ 25h	;Funktionscode Set Interrupt Vector
	IRQ10	equ 72h	        ;Vektor 72h fuer IRQ10
        EOI     equ 20h         ;End of Interrupt (=20h)

;Ŀ
;  Konstanten fuer den Timerbaustein 8253                                 
;
	Timer0	equ 0304h	;Adresse Datenregister Zaehler 0
	Timer1	equ 0305h	;Adresse Datenregister Zaehler 1
	Timer2	equ 0306h	;Adresse Datenregister Zaehler 2
	TimerContr equ 0307h	;Adresse Controlregister

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA		equ 300h;Adresse Port A
	PortB		equ 301h;Adresse Port B
	CntlReg		equ 303h;Adresse Kontrollregister
	LslReset	equ 9Bh

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG
        	Counter         dd Timer
        	status          dw THgruen      , 00110011b
                	        dw 0            , 00110011b
                        	dw Tgelb        , 11110101b
                        	dw TNrot_THrot  , 11110110b
                        	dw Tgelb        , 11100110b
                        	dw TNgruen      , 11011110b
                        	dw Tgelb        , 11101110b
                        	dw TNrot_THrot  , 11110110b
                        	dw Tgelb        , 11110100b
                        	dw 0ffffh

;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG
	Vec_Seg		dw ?	;zur Sicherung von Routine-Segment bei IRQ
	Vec_Ofs	  	dw ?	;zur Sicherung von Routine-Offset bei IRQ
	IRQStatus 	db ?	;Status der Interruptroutine (0= aus, 1= ein)
	Trig		db ?

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;
;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren
        push    dx
        push    ax
        mov     al, 8bh
        mov     dx, CntlReg
        out     dx, al
        pop     ax
        pop     dx
	ret		;Ruecksprung
InitPorts endp		;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen
        push    dx
        push    ax
        mov     al, 9bh
        mov     dx, CntlReg
        out     dx, al
        pop     ax
        pop     dx
	ret		;Ruecksprung
ResetPorts endp		;Unterprogramm Ende

;Ŀ
;  Einfuegen der Interruptroutine in die Vektortabelle                    
;
InitInter proc	
	push    ax		;Register sichern
	push 	dx

	mov 	ah,GetIntVec	;Funktionscode Get Interrupt Vector
	mov 	al,IRQ10	;IRQ10 wird verwendet, d.h. Vektor 72h
	int 	MSDOS		;int 21h
	mov 	[Vec_Seg],es	;Segment der Routine abspeichern
	mov 	[Vec_Ofs],bx	;Offset der Routine abspeichern

	mov	ah,SetIntVec	;Funktionscode Set Interrupt Vector
	mov 	al,IRQ10	;Vektornummer laden
	push 	ds		;ds wird noch gebraucht => Register sichern	
	push 	cs		;die neue Interruptroutine steht im gleichen Segment
	pop 	ds		;daher wird der Inhalt von CS nach DS uebertragen
	mov 	dx,offset Inter1;Offset der Routine nach DX
	int 	MSDOS		;int 21h

	pop 	ds		;Register restaurieren
	pop 	dx
	pop 	ax
	ret
InitInter endp

;Ŀ
;  Interrupts auf IRQ10 freigeben                                         
;
IRQ_On proc	
	push    ax		;Register sichern
	in      al,IRQMask_2	;Mask-Register des 2. Controllers
	and     al,0FBh		;Bit 2 loeschen, gibt IRQ 10 frei
	out     IRQMask_2,al	;Byte zurueckschreiben
	STI			;maskierbare Interrupts freigeben
	pop     ax		;Register restaurieren
	ret
IRQ_On endp	

;Ŀ
;  IRQ10 ausschalten                                                      
;
IRQ_Off	proc
	push 	ax              ;Register sichern
	in 	al,IRQMask_2	;Mask-Register 2. Controller
	or 	al,04h		;Bit 2 setzen, sperrt Interrupts auf IRQ10
	out 	IRQMask_2,al	;Byte zurueckschreiben	
	pop 	ax
	ret
IRQ_Off	endp

;Ŀ
;  alte Interruptroutine wieder eintragen                                 
;
ResetInter proc
	push 	ax              ;Register sichern
	push 	dx
	push 	ds			
	mov 	ds,[Vec_Seg]	;Segment der Routine nach DS
	mov 	dx,[Vec_Ofs]	;Offset der Routine nach DX
	mov 	ah,SetIntVec	;Funktion Set Interrupt Vector
	mov 	al,IRQ10	;Vektornummer laden
	int	MSDOS		;int 21h
	pop 	ds		;Datensegment restaurieren
	pop 	dx		;Register sichern
	pop 	ax
	ret
ResetInter endp


;Ŀ
;  Timer 1 und 2 vorbereiten                                              
;
InitTimer proc
        push    ax
        push    dx
        mov     dx, TimerContr
        mov     ax, 01110100b
        out     dx, al
        mov     dx, Timer1
        mov     ax, word ptr Counter
        inc     ax
        out     dx, al
        mov     al, ah
        out     dx, al
        mov     dx, TimerContr
        mov     ax, 10110100b
        out     dx, al
        mov     dx, Timer2
        mov     ax, word ptr [Counter+2]
        inc     ax
        out     dx, al
        mov     al, ah
        out     dx, al
        pop     dx
        pop     ax
	ret
InitTimer endp

;Ŀ
;  Interruptroutine (und mehr wird hier nicht gemacht!!!!!!!!!!!!)        
;                   ("IRQStatus" wird im Hauptprogramm abgefragt!)        
;
Inter1	proc            	;Interruptroutine          
	push 	ax		;Register sichern
	push 	ds	
		
	mov 	ax,@DATA	;Datensegment laden
	mov 	ds,ax		;Ab jetzt kann auf Variablen zugegriffen werden
	
        mov 	[IRQStatus],1h	;Interruptroutine aufgerufen

	mov 	al,EOI		;End-Of-Interrupt-Code laden
	out 	Master,al	;Controllregister Controller 1
	out 	Slave,al	;Controllregister Controller 2
	pop 	ds		;Register restaurieren
	pop 	ax		;Register restaurieren
	iret			;Ende der Interruptroutine
Inter1	endp


;͸
; Hauptprogramm                                                            
;;
Main:	mov     ax,@DATA	;Datensegment laden
	mov     ds,ax
	call    InitPorts	;I/O-Baustein 8255 initialisieren
	call    InitInter   	;Interruptroutine in Vektortabelle eintragen 
	call    IRQ_On	        ;Interrupt einschalten (freigeben)
	call    InitTimer       ;Timer fuer Programmierung vorbereiten
        mov 	[IRQStatus],0   ;InterruptStatusflag zuruecksetzen

        mov     [Trig], 0
Sprg1:  mov     si, offset (status)

Sprg2:
        lodsw
        cmp     ax, 0ffffh
        je      Sprg1
        mov     cx, ax
        lodsw
        mov     dx, PortA
        out     dx, al
        mov 	bx,ax
        mov     dx, PortB
Sprg3:  
	in      al, 60h
        cmp     al, 1
        je      Sprg5
        in      al, dx
        test    al, 10000000b
        jne     Sprg4
        cmp 	bl,11011110b
        je 	Sprg4
        mov     [Trig], 1
Sprg4:
        jcxz    Sprg6
        cmp     [IRQStatus], 1
        jne     Sprg3
        mov     [IRQStatus], 0
        loop    Sprg3
        jmp     Sprg2

Sprg5:
	call    IRQ_Off	        ;Interrupt ausschalten 
	call 	ResetInter	;alte Interruptroutine wieder eintragen
	call 	ResetPorts	;Zuruecksetzen des 8255
	xor	ax,ax		;Programm beenden
	mov     ah,Exit
	int     msdos
Sprg6:
        cmp     [Trig], 1
        jne     Sprg3
        mov     [Trig], 0
        mov     [IRQStatus], 0
Sprg7:
        in      al, 60h
        cmp     al, 1
        je      Sprg5
        cmp     [IRQStatus], 1
        jne     Sprg7
        mov     [IRQStatus], 0
        jmp     Sprg2

end	Main

