/*ͻ
   Modul     Berech.h                                                    
                                                                         
   Compiler  Borland C++ 3.1                                             
                                                                         
   Datum     Karlsruhe, den 04.07.94                                     
                                                                         
   Autor     A. Seifert                                                  
                                                                         
   Update    04.07.1994, Hartung Wilstermann                             
  Ķ
   Inhalt    Berechnung der Sinus, Cosinus, Rechteck und Zufallswerte    
             Wertebereich: 0..4096                                       
  ͼ*/

/*ͻ
   Modulkopf                                                              
  ͼ*/
  #ifndef _BERECH_H
  #define _BERECH_H

/*Ŀ
   Includedateien einladen                                                
  */
  #include <time.h>    		//Zufallsgenerator einbinden

/*ͻ
   Unterprogramme                                                         
  ͼ*/

/*Ŀ
   Sinus                                                                  
  */
  void sinus(void)
  {
    int i;

    for (i=0; i != maxwert; i++)
    {
      werte[i]=4096/2+sin(i*2*M_PI*2/((float)maxwert))*4095/2;
    }
  };


/*Ŀ
   Rechteck                                                               
  */
  void rechteck(void)
  {
    int i;

    for (i=0; i != maxwert; i++)
    {
      werte[i]=ceil(0.5*sin(i*2*M_PI*2/((float)maxwert)))*4095;
    }
  };


/*Ŀ
   Rampe                                                                  
  */
  void drei(void)
  {
    int i;

    for (i=0; i != maxwert; i++)
    {
      werte[i]=i/(float)maxwert*4095;
    }
  };


/*Ŀ
   Zufall: berechnet eine Funktion, die aus der Additon zweier Sinus-     
  	    Funktionen mit zuflligen Amplituten und Frequenzen besteht    
  */
  void zufall(void)
  {
    int i;
    float amp1;
    float freq1;
    float amp2;
    float freq2;
    float kurve1;
    float kurve2;

    randomize();            	//Zufallsgenerator initalisieren
    amp1= (random(19)+1)/20.0;	//Zufallsfrequenzen erzeugen
    freq1=(random(9)+1);
    amp2= (random(9)+1)/30.0;
    freq2=(random(9)+1)*3;

    for ( i=0; i != maxwert; i++)
    {
      kurve1=amp1*4095*sin(i*2*M_PI*freq1/(float)maxwert);
      kurve2=amp2*4095*sin(i*2*M_PI*freq2/(float)maxwert);
      werte[i]=(4096/2+(kurve1+kurve2)/4);
    }
  };

  #endif
